# RPC client and server

Client requests a date.

Used to test RPC from Tandem host to PC.

- date.x is the RPC idl input file
- user created/modified source files are in src/
- link and load files are put into objs/
- rpcgen output is put into rpcgen_output/

To build, run `make`.

To run in Ubuntu (each command in a separate window):

- `sudo rpcbind -af`
- `./objs/date_server`

You can now dump the local port mapper with `rpcinfo -p` and send a rpc ping to
the program with `rpcinfo -t 127.0.0.1 1350013500`.

Sample output:

```text
: rpcinfo -p
   program vers proto   port  service
    100000    4   tcp    111  portmapper
    100000    3   tcp    111  portmapper
    100000    2   tcp    111  portmapper
    100000    4   udp    111  portmapper
    100000    3   udp    111  portmapper
    100000    2   udp    111  portmapper
1350013500    1   tcp  37623

: rpcinfo -t 127.0.0.1 1350013500
program 1350013500 version 1 ready and waiting
```

## Limits

1. The program number, 1350013500 (0x5077923C), is hard coded. In principle, it
   should be generated. See [Using Transient RPC Program
   Numbers](https://docs.oracle.com/cd/E18752_01/html/816-1435/advrpcpt-37.html)

The following about program numbers is copied from [Program and Procedure
Numbers](https://docs.oracle.com/cd/E37838_01/html/E61058/rpcproto-79628.html)

**Program Number Assignment**
Program numbers are distributed in groups of 0x20000000, as shown in the following table.

### Table 16  RPC Program Number Assignment

| Program Numbers     | Description     |
| ------------------- | --------------- |
| 00000000 - 1fffffff | Defined by host |
| 20000000 - 3fffffff | Defined by user |
| 40000000 - 5fffffff | Transient (reserved for customer-written applications) |
| 60000000 - 7fffffff | Reserved        |
| 80000000 - 9fffffff | Reserved        |
| a0000000 - bfffffff | Reserved        |
| c0000000 - dfffffff | Reserved        |
| e0000000 - ffffffff | Reserved        |

Oracle administers the first group of numbers, which should be identical for all customers. If a customer develops an application that might be of general interest, that application should be given an assigned number in the first range.

The second group of numbers is reserved for specific customer applications. This range is intended primarily for debugging new programs.

The third group is reserved for applications that generate program numbers dynamically.

The final groups are reserved for future use, and should not be used
