/* date.x is input to rpcgen. */

program DATE_PROG {   /* remote program name (not used) */
  version DATE_VERS { /* declaration of program version number */
    /* The XDR type "string" is a null terminated char array. Because a length
       is not specified, its maximum length is (2**32) - 1).
    */
    string GET_REMOTE_DATE(string) = 1; /* Procedure number */
  }
  = 1; /* Program version */
} = 1350013500; /* remote program number */

/* https://docs.oracle.com/cd/E19455-01/805-7224/6j6q44cgg/index.html
 * TI-RPC allows a single parameter to be passed from client to server. If
 * more than one parameter is required, the components can be combined into a
 * structure, that is counted as a single element.
 * Information passed from server to client is passed as the function's return
 * value. Information cannot be passed back from server to client through the
 * parameter list.
 */
