/*
 * Client program. Modified from a template generated by rpcgen.
 */

#include <stdlib.h>
#include <time.h>

#include <date.h>

char** date_prog_1(char *host, char *printable_date_1_arg) {
  CLIENT *clnt;
  char** result_1;

#ifndef DEBUG
  clnt = clnt_create(host, DATE_PROG, DATE_VERS, "tcp");
  if (clnt == NULL) {
    clnt_pcreateerror(host);
    exit(EXIT_FAILURE);
  }
  // change timeout to 60 seconds
  struct timeval timeout;
  timeout.tv_sec = 60;
  timeout.tv_usec = 0;
  clnt_control(clnt, CLSET_TIMEOUT, (char*)&timeout);
#endif /* DEBUG */

  result_1 = get_remote_date_1(&printable_date_1_arg, clnt);
  if (result_1 && *result_1 != NULL) {
    printf("%s:%d - get_remote_date_1 returned \"%s\"\n", __FILE__, __LINE__,
           *result_1);
  }
  else {
    clnt_perror(clnt, "call failed");
  }

#ifndef DEBUG
  clnt_destroy(clnt);
#endif /* DEBUG */
  return result_1;
}

int main(int argc, char *argv[]) {
  char *host;
  char buffer[80] = "client initial data";

  if (argc < 2) {
    printf("usage: %s server_host\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  host = argv[1];

  printf("%s:%d - sending %lu bytes \"%s\"\n", __FILE__, __LINE__,
         strlen(buffer), buffer);
  char** r = date_prog_1(host, buffer);
  if (r && *r != NULL) {
    printf("%s:%d - got %lu bytes \"%s\"\n", __FILE__, __LINE__, strlen(*r),
           *r);
    free(*r);
  }
  return EXIT_SUCCESS;
}
